/* REXX: MYDEL
**
** Usage: filenames with wildcards...
**
** There are two flags that can be used in the argument stream
**   -I include the following filenames
**   -E exclude the following filenames
**
** Ex:
**   mydel * -E readme.txt
**   deletes all files except readme.txt
*/
parse arg szArgs

rc = rxfuncadd( 'SysFileTree',   'REXXUTIL', 'SysFileTree'   )
rc = rxfuncadd( 'SysFileDelete', 'REXXUTIL', 'SysFileDelete' )

fInclude       = 1
aIncludeList.0 = 0
aExcludeList.0 = 0

do while 0 < words( szArgs )
   parse var szArgs szArg szArgs

   if translate( szArg ) = "-X" then
      fInclude = 0
   else if translate( szArg ) = "-I" then
      fInclude = 1
   else
   do
      if fInclude then
         call fAddToList 'aIncludeList' szArg
      else
         call fAddToList 'aExcludeList' szArg
   end
end

do i = 1 to aIncludeList.0
   do j = 1 to aExcludeList.0
      if aIncludeList.i = aExcludeList.j then
         aIncludeList.i = ""
   end
end

/*
say "Including:"
do i = 1 to aIncludeList.0
   say aIncludeList.i
end

say
say "Excluding:"
do i = 1 to aExcludeList.0
   say aExcludeList.i
end
*/

do i = 1 to aIncludeList.0
   if aIncludeList.i \= "" then
      rc = SysFileDelete( aIncludeList.i )
end

exit 0

/****************************************************************/
fAddToList: parse arg stem szWildcard .

rc = SysFileTree( szWildCard, 'aFiles', 'FO' )

do i = 1 to aFiles.0
   interpret( stem'.0 = 'stem'.0 + 1' )
   interpret( 'j = 'stem'.0' )
   interpret( stem'.j = aFiles.i' )
end

return
