/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
// Written by Mark Hamzy

#include <stdio.h>
#include <string.h>

char achBuffer[4096];

void
PrintUsage (char *pszExeName)
{
   fprintf (stderr, "Usage: %s [-a] [output_file]\n", pszExeName);
   fprintf (stderr, "       Reads stdin and outputs to stdout.\n");
   fprintf (stderr, "       if output_file is given, then a copy will be stored in output_file.\n");
   fprintf (stderr, "       if -a is specified then the output will be appended to output_file.\n");
}

int
main (int argc, char *argv[])
{
   char        *pszFileNameOut = NULL;
   char        *pszMode        = "w";
   int          iBytesRead;
   FILE        *fp             = NULL;
   register int i;

   // Read the parameters
   for (i = 1; i < argc; i++)
   {
      if (('-' == argv[i][0]) ||
          ('/' == argv[i][0])  )
      {
         static char *pszAppend = "a";

         if (0 == strnicmp (argv[i] + 1, pszAppend, strlen (pszAppend)))
         {
            pszMode = "a";
         }
         else
         {
            PrintUsage (argv[0]);
            goto exit;
         }
      }
      else
         pszFileNameOut = argv[i];
   }

   if (pszFileNameOut)
   {
      fp = fopen (pszFileNameOut, pszMode);
      if (!fp)
         fprintf (stderr,
                  "Error: Could not open '%s' for writing.\n",
                  pszFileNameOut);
   }

   while (!feof (stdin))
   {
      if (fgets (achBuffer, sizeof (achBuffer) - 1, stdin))
      {
         iBytesRead = strlen (achBuffer);
         fwrite (achBuffer, iBytesRead, 1, stdout);
         if (fp)
            fwrite (achBuffer, iBytesRead, 1, fp);
      }
   }

   if (fp)
      fclose (fp);

exit:
   return 0;
}
