/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = ASSRT.H
 *
 * DESCRIPTION = Debug output routines and debug assertions
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 04/01/94
 * AUTHOR  = Mark Hamzy
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_assrt_h
#define _gpl_assrt_h

extern BOOL   Assert;
extern BOOL   AssertBeep;
extern BOOL   AssertWarp;

typedef VOID (* APIENTRY PDEBUG_CALLBACK_FUN) (char * pszBuffer, ULONG cbLen);

/* Predefined functions...
*/
#define HOOKTYPE_PMPRINTF    (PDEBUG_CALLBACK_FUN)-1
#define HOOKTYPE_DEBUGOUT    (PDEBUG_CALLBACK_FUN)-2

VOID APIENTRY GplHookAssert  (PDEBUG_CALLBACK_FUN pfnCallback);

#ifdef DEBUG
  // build debug version

  // for the assert( expression ) macro
  void _System GplReportFailedAssertion( BOOL bool, ULONG ulLine, char * pszFilename, char * pszExpression );

  // A special thanks goes to Pat "Mr. C++" Davis
#if 0
  #define assertT(exp)      do{if (exp)    GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(char *)#exp);}while (((LONG)exp)^((LONG)exp))
  #define assertF(exp)      do{if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(char *)#exp);}while (((LONG)exp)^((LONG)exp))
  #define assert(exp)       do{if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(char *)#exp);}while (((LONG)exp)^((LONG)exp))
  #define assertstring(str) {GplReportFailedAssertion(TRUE, __LINE__, __FILE__, (char *)str);}
#else
  #define assertT(exp)  {if (exp)    GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define assertF(exp)  {if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define assert(exp)   {if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define assertstring(str) {GplReportFailedAssertion(TRUE, __LINE__, __FILE__, (PSZ)str);}
#endif

  #define ASSERTT(exp)  {if (exp)    GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define ASSERTF(exp)  {if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define ASSERT(exp)   {if (!(exp)) GplReportFailedAssertion((BOOL)(exp),__LINE__,__FILE__,(PSZ)#exp);}
  #define ASSERTSTRING(str) {GplReportFailedAssertion(TRUE, __LINE__, __FILE__, (PSZ)str);}

  // NOTE: The following *must* appear in your .def file!
  //
  // IMPORTS
  //     Debug32Output         = PMWIN.955

  INT  APIENTRY Debug32Output (PCH);

  // for the DBPRINTF((pszFormat, ... )) macro
  VOID _Optlink Gpldbprintf (char * pszFormat, ...);
  #define DBPRINTF(str) Gpldbprintf str

  VOID _Optlink Gpldbprintif (BOOL Doit, char * pszFormat, ...);
  #define DBPRINTIF(str) Gpldbprintif str

  // Produces output as follows:
  //   PRINT_VAR(ulWidth);
  //
  //   ulWidth = 10
  //
  #define PRINT_VAR(x)        DBPRINTF  ((#x" = %d\n", x))
  #define PRINT_VARIF(b,x)    DBPRINTIF ((b, #x" = %d\n", x))

  #define PRINT_VARt(x,t)     DBPRINTF  ((#x" = %"#t"\n", x))
  #define PRINT_VARtIF(b,x,t) DBPRINTIF ((b, #x" = %"#t"\n", x))

#else
  // retail version
  #define assertT(exp)        ;
  #define assertF(exp)        ;
  #define assert(exp)         ;
  #define assertstring(str)   ;
  #define ASSERTT(exp)        ;
  #define ASSERTF(exp)        ;
  #define ASSERT(exp)         ;
  #define ASSERTSTRING(str)   ;
  #define DBPRINTF(str)
  #define DBPRINTIF(str)
  #define PRINT_VAR(x)        ;
  #define PRINT_VARIF(b,x)    ;
  #define PRINT_VARt(x,t)     ;
  #define PRINT_VARtIF(b,x,t) ;
#endif


BOOL APIENTRY PMAssert   (BOOL, HAB, char *);
BOOL APIENTRY BaseAssert (ULONG, char *);

#endif
