/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = COMPRESS.H
 *
 * DESCRIPTION = Public header information for compress functions(COMPRESS.C)
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 05/05/94
 * AUTHOR  = MikeJ
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_compress_h
#define _gpl_compress_h


// compression routines return -1 in event of error
#define GPLCOMPRESS_ERROR      -1

// lMaxCapable/return values for GplCompressWhich()
#define GPLCOMPRESS_INVALID      -1  // @newmode
#define GPLCOMPRESS_NONE          0
#define GPLCOMPRESS_RLL           1
#define GPLCOMPRESS_TIFF          2
#define GPLCOMPRESS_DELTAROW      4
#define GPLCOMPRESS_RLLDELTAROW   8

#define MAXCOMPRESSRLLDELTAROW    9
#define MAXCOMPRESSDELTAROW       3
#define MAXCOMPRESSTIFF           2
#define MAXCOMPRESSRLL            1
#define MAXCOMPRESSNONE           0

#define COLOR_TECH_MONO           0
#define COLOR_TECH_COLOR          1
#define COLOR_TECH_K              2
#define COLOR_TECH_CMY            3
#define COLOR_TECH_CMYK           4
#define COLOR_TECH_KCMY           5

#ifndef _genplib_compressinfo
  #define _genplib_compressinfo
typedef struct _CompressStruc {
        ULONG         ulColorTech;
   ULONG         ulBytesPerRow;
   ULONG         ulBlankLineCount;
   ULONG         ulSupportedCompModes;
   INT           iCurrentCompMode;
   INT           iMaxCompMode;
   PBYTE         pbCompress;
   PUSHORT       pusDelta;
   PBYTE         pbLastLineX;
   PBYTE         pbLastLineY;
   PBYTE         pbLastLineZ;
   PBYTE         pbLastLineK;
   } COMPRESSINFO, *PCOMPRESSINFO;
#endif

INT  APIENTRY GplCompressChooseMode ( PBYTE pbCurrent, PBYTE pbPrevious, INT RowCount, ULONG CompressModes, PUSHORT pDelta );

LONG APIENTRY GplCompressRLL ( PBYTE pbDataIn, LONG cbDataIn, PBYTE pbDataOut, LONG cbDataOut );

LONG APIENTRY GplCompressTIFF ( PBYTE pbDataIn, LONG cbDataIn, PBYTE pbDataOut, LONG cbDataOut );

INT  APIENTRY  GplCompressDeltaRow ( INT usTotalBytes,  // bytes in the scan line
                  PBYTE  pbData,         // raster data to compress
                  PBYTE  pbLastLine,     // previous scanline's raster data
                  INT    usMaxReturn,    // length of output buffer
                  PBYTE  pbReturn  ,     // compressed data will be written
                  PUSHORT pDeltas );     // differences indexes - (Start, End) pairs

INT APIENTRY GplCompressRLLDeltaRow ( INT usTotalBytes,  // bytes in the scan line
                  PBYTE  pbData,         // raster data to compress
                  PBYTE  pbLastLine,     // previous scanline's raster data
                  INT    usMaxReturn,    // length of output buffer
                  PBYTE  pbReturn  ,     // compressed data will be written
                  PUSHORT pDeltas );     // differences indexes - (Start, End) pairs

APIRET APIENTRY GplCompressCreateInstance ( PCOMPRESSINFO Comp, PVOID Hmcb );

APIRET APIENTRY GplCompressDeleteInstance ( PCOMPRESSINFO Comp );

VOID APIENTRY GplCompressZeroLastLineBuffers ( PCOMPRESSINFO Comp );

#endif
