/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
#ifndef _genplib_fontsub_ph
#define _genplib_fontsub_ph

#include "fontsub.h"





/*
** Defines for dialog box.
*/
#define GFSID_BASE                  0x8075

#define GFSID_FSDIALOG              (GFSID_BASE + 1)
#define GFSID_LBSYS                 (GFSID_BASE + 2)
#define GFSID_LBDEV                 (GFSID_BASE + 3)
#define GFSID_FSDIALOGTAB           (GFSID_BASE + 4)

#define GFSID_SYSGROUP              (GFSID_BASE + 6)
#define GFSID_SYSTEXT               (GFSID_BASE + 7)
#define GFSID_DEVGROUP              (GFSID_BASE + 8)
#define GFSID_DEVTEXT               (GFSID_BASE + 9)
#define GFSID_NOSUB                 (GFSID_BASE + 10)
#define GFSID_MATCHFONTNAMES        (GFSID_BASE + 11)
#define GFSID_UNDO                  (GFSID_BASE + 12)
#define GFSID_DEFAULT               (GFSID_BASE + 13)

// This identifies the font substitution data as unique.
#define GFSCB_CB_ID                 "GPLFONTSUB"

/*
** Current version for the Font substitution control block.
** It is not recommended that this be changed unless the font
** substitution control block is updated.
*/
#define GFSCB_CB_VERSION            1

// Handle used for "No font substitution" listbox item string.
#define NOFONTSUB_HANDLE            -1

/*
** Separators used for font mapping in the INI.  GROUPITEM_SEPARATOR separates
** each string within a group.  GROUP_SEPARATOR separates each font
** mapping group.
*/
#define INI_GROUPITEM_SEPARATOR     ','
#define INI_GROUP_SEPARATOR         ';'



// STUFF TO PASS TO FONT SUBSTITUTION DIALOG PROCEDURE.
// this is data the dialog procedure for font subusitution
// uses when it is called back.
typedef struct _FSDlgData
{
  GFSCB  fontsubCB;                     // Font substitution Control Block

  HWND   hSysFontList;                  // System font listbox handle
  HWND   hDevFontList;                  // Device font listbox handle

  PSZ    pDeviceName;                   // Device name.
  ULONG  ulMaxBuffSize;                 // Maximum size of font buffer
  PCHAR  pFontBuff;                     // Font buffer pointer

  USHORT usFlags;                       // General flags
         // If set, then do not update system fonts.
         #define NO_SYSFONT_UPDATE      1
} FSDLGDATA, *PFSDLGDATA;


/*
** GENPLIB Font Substitution Output Instance
** This is used by the GplFontsub...Instance() API's.  This contains a control
** block (GFSCB) as well as additional information needed to do
** Font Substitution.
*/
typedef struct _GJFOI
{
  // control block
  GFSCB gfscb;

  // font substitution data.
  PSZ   fsData;
} GJFOI, *PGJFOI, **PPGJFOI;





/*
** Function prototypes...
*/
LONG    GplpFontsubInitCB( PGFSCB, PSZ );
MRESULT EXPENTRY GplpFontsubDlgProc( HWND, ULONG, MPARAM, MPARAM );
BOOL    GplpFontsubSaveSelections( PFSDLGDATA );
PSZ     GplpFontsubReadINI( PSZ, PSZ );





#endif // _genplib_fontsub_ph

