/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = FXMATH.H
 *
 * DESCRIPTION =
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 9/01/96
 * AUTHOR  = Larry Moore
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_fxmath_h
#define _gpl_fxmath_h

FIXED APIENTRY GplFXMathSine( FIXED );
FIXED APIENTRY GplFXMathCosine( FIXED );
FIXED APIENTRY GplFXMathMultiply( FIXED, FIXED );
FIXED APIENTRY GplFXMathDivide( FIXED, FIXED, PLONG );
//*****************************************************************************
//
//  FUNCTION: GplPointToPoint
//
//  PARAMETERS:
//
//  PPOINTL  pCoord1
//  PPOINTL  pCoord2
//
//  DESCRIPTION:
//
//  Compute the distance between two points, given in pCoord1 and pCoord2.
//  This function applies the Pythagorean Theorem to the points and returns a
//  FIXED value for the distance between the two points.
//
//  Pythagorean's Theorem:
//
//  Distance between any two points may be expressed as follows:
//                  ________________________
//      Distance = (x2 - x1) + (y2 - y1)
//
//  Simply plug in the parameters and go!
//
//  RETURNS: FIXED result
//
//*****************************************************************************
FIXED APIENTRY GplPointToPoint( PPOINTL, PPOINTL );

//*****************************************************************************
//
//  FUNCTION: GplNormalize
//
//  PARAMETERS:
//
//  PPOINTL  pOrigPoint - original description of rotation x and y units.
//           Can be any eg 179 degrees can be x -999, y 17
//  PPOINTL  pNormalPoint this is x and y as same ratio BUT between -1 and 1
//           This in FIXED - not longs
//
//  DESCRIPTION:
//
//  Will Normalize the rotation meaning it is between values are between -1 to 1
//  Will be in FIXED units
//
//  Since many angles are represented as the slope of X units and Y units they
//  can be any many ways to express the same angle.  When the value is
//  normalized it can be multiplied directly against coordinate distances to
//  get new distance/positions
//
//                     x                       y
//      NormalX =   _______     NormalY =   _______
//                 x + y                x + y
//
//  RETURNS: FIXED BOOL   TRUE = OK
//
//
//*****************************************************************************
BOOL  APIENTRY GplNormalize( PPOINTL, PPOINTL );

//*****************************************************************************
//
//  FUNCTION: GplLLongXFixed
//
//  PARAMETERS:
//
//  LONG lNum: Long Number
//  FIXED fxNum: Fixed Number
//
//  DESCRIPTION:
//
//  Multiplies a long times fixed.  First the long is multiplied by int part
//  of fixed.  Then this is added to long times frac which is truncated
//
//  RETURNS: LONG
//
//*****************************************************************************
LONG  APIENTRY GplLLongXFixed ( LONG, FIXED );

#endif
