/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = GENPLIB.H
 *
 * DESCRIPTION = This module contains all MACROS, IDs, constants and
 *               data type definitions used by the library of functions
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 10-07-93
 * AUTHOR  = Mark Hamzy, Mark VanderWiele
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#if __cplusplus
extern "C"
{
#endif

#ifdef INCL_GENPLIB_THREAD
#define INCL_GENPLIB_MEMORY    // thread mod has dependencies on memory mod
#endif

#ifdef INCL_GENPLIB_PATTERNS
#define INCL_GENPLIB_MEMORY    // pattern mod has dependencies on memory mod
#endif

#ifdef INCL_GENPLIB_GAMMA      // Gamma is a subset of dithering
#define INCL_GENPLIB_DITHER
#endif

#ifdef INCL_GENPLIB_FONTSUB
  #define INCL_GENPLIB_MEMORY

  #ifndef INCL_GENPLIB_JOBFEATURES
    #define INCL_GENPLIB_JOBFEATURES
  #endif

  #ifndef INCL_GENPLIB_CTRLLISTBOX
    #define INCL_GENPLIB_CTRLLISTBOX
  #endif
#endif

#ifdef INCL_GENPLIB_JOBFEATURES
  #ifndef INCL_GENPLIB_MEMORY
    #define INCL_GENPLIB_MEMORY
  #endif

  #ifndef INCL_GENPLIB_DIALOGPAGES
    #define INCL_GENPLIB_DIALOGPAGES
  #endif

  #ifndef INCL_GENPLIB_ERROR
    #define INCL_GENPLIB_ERROR
  #endif

  #ifndef INCL_GENPLIB_ASSERT
    #define INCL_GENPLIB_ASSERT
  #endif
#endif

#ifdef INCL_GENPLIB_LAYOUT
  #define INCL_GENPLIB_MEMORY

  #ifndef INCL_GENPLIB_JOBFEATURES
    #define INCL_GENPLIB_JOBFEATURES
  #endif

  #ifndef INCL_GENPLIB_DIALOGPAGES
    #define INCL_GENPLIB_DIALOGPAGES
  #endif

  #ifndef INCL_GENPLIB_FIXEDMATH
    #define INCL_GENPLIB_FIXEDMATH
  #endif

  #ifndef INCL_GENPLIB_CTRLLISTBOX
    #define INCL_GENPLIB_CTRLLISTBOX
  #endif

  #ifndef INCL_GENPLIB_NUP
    #define INCL_GENPLIB_NUP
  #endif

  #ifndef INCL_GENPLIB_BOOKLET
    #define INCL_GENPLIB_BOOKLET
  #endif

#endif

#ifdef INCL_GENPLIB_JOBFEATURES
  #ifndef INCL_GENPLIB_DIALOGPAGES
    #define INCL_GENPLIB_DIALOGPAGES
  #endif
#endif

#ifdef INCL_GENPLIB_ALL
#define INCL_GENPLIB_STRINGSORT
#define INCL_GENPLIB_JOURNAL
#define INCL_GENPLIB_THREAD
#define INCL_GENPLIB_ERROR
#define INCL_GENPLIB_ASSERT
#define INCL_GENPLIB_MEMORY
#define INCL_GENPLIB_HANDLER
#define INCL_GENPLIB_UTIL
#define INCL_GENPLIB_SEMAPHORES
#define INCL_GENPLIB_COMPRESS
#define INCL_GENPLIB_PATTERNS
#define INCL_GENPLIB_DITHER
#define INCL_GENPLIB_FAX
#define INCL_GENPLIB_QUERYMEM
#define INCL_GENPLIB_NUP
#define INCL_GENPLIB_JOBFEATURES
#define INCL_GENPLIB_DIALOGPAGES
#define INCL_GENPLIB_CIRCULARSLIDER
#define INCL_GENPLIB_SAMPLEPAGE
#define INCL_GENPLIB_GPLUTIL
#define INCL_GENPLIB_MEMINI
#define INCL_GENPLIB_RUNTIME
#define INCL_GENPLIB_LAYOUT
#define INCL_GENPLIB_BOOKLET  
#define INCL_GENPLIB_EDC
#define INCL_GENPLIB_FONTMGR
#define INCL_GENPLIB_WEBPAGE
#endif

#ifdef INCL_GENPLIB_MEMORY
   #ifndef __genplib_h_memory
   #define __genplib_h_memory
      #include <mem.h>
   #endif
#endif

#ifdef INCL_GENPLIB_QUERYMEM
   #ifndef __genplib_h_QUERYMEM
      #define __genplib_h_QUERYMEM
      #include <querymem.h>
   #endif
#endif

#ifdef INCL_GENPLIB_STRINGSORT
   #ifndef __genplib_h_strsort
   #define __genplib_h_strsort
      #include <sorter.h>
   #endif
#endif

#ifdef INCL_GENPLIB_JOURNAL
   #ifndef __genplib_h_journal
   #define __genplib_h_journal
      #include <journal.h>
   #endif
#endif

#ifdef INCL_GENPLIB_THREAD
   #ifndef __genplib_h_thread
   #define __genplib_h_thread
      #include <thread.h>
   #endif
#endif

#ifdef INCL_GENPLIB_THREAD_WRITE
   #ifndef __genplib_h_thread_write
   #define __genplib_h_thread_write
      #include <thdwrite.h>
   #endif
#endif

#ifdef INCL_GENPLIB_ERROR
   #ifndef __genplib_h_error
   #define __genplib_h_error
      #include <err.h>
   #endif
#endif

#ifdef INCL_GENPLIB_ASSERT
   #ifndef __genplib_h_assert
   #define __genplib_h_assert
      #include <assrt.h>         // Conflicts with assert.h in C include
   #endif
#endif

#ifdef INCL_GENPLIB_HANDLER
   #ifndef __genplib_h_handler
   #define __genplib_h_handler
      #include <setjmp.h>             // handler has a dependency on C runtime
      #include <handler.h>
   #endif
#endif

#ifdef INCL_GENPLIB_UTIL
   #ifndef __genplib_h_util
   #define __genplib_h_util
      #include <utilasm.h>
   #endif
#endif

#ifdef INCL_GENPLIB_UTIL
   #ifndef __genplib_h_semaphores
      #define __genplib_h_semaphores
      #include <sem.h>
   #endif
#endif

#ifdef INCL_GENPLIB_COMPRESS
   #ifndef __genplib_h_compress
      #define __genplib_h_compress
      #include <compress.h>
   #endif
#endif

#ifdef INCL_GENPLIB_PATTERNS
   #ifndef __genplib_h_patterns
      #define __genplib_h_patterns
      #include <pattern.h>
   #endif
#endif

#ifdef INCL_GENPLIB_DITHER
  #ifndef __genplib_h_dither
    #define __genplib_h_dither
    #include <dither.h>
  #endif
#endif

#ifdef INCL_GENPLIB_FAX
  #ifndef __genplib_h_fax
    #define __genplib_h_fax
    #include <fax.h>
  #endif
#endif

#ifdef INCL_GENPLIB_DIALOGPAGES
  #ifndef __genplib_h_dialogpages
    #define __genplib_h_dialogpages
    #include <dlgpage.h>
  #endif
#endif

#ifdef INCL_GENPLIB_JOBFEATURES
  #ifndef __genplib_h_jobfeatures
    #define __genplib_h_jobfeatures
    #include <jobfeat.h>
  #endif
#endif

#ifdef INCL_GENPLIB_SAMPLEPAGE
  #ifndef __genplib_h_samplepage
    #define __genplib_h_samplepage
    #include <sampage.h>
  #endif
#endif

#ifdef INCL_GENPLIB_CIRCULARSLIDER
  #ifndef __genplib_h_knob
    #define __genplib_h_knob
    #include <knob.h>
  #endif
#endif

#ifdef INCL_GENPLIB_NUP
  #ifndef __genplib_h_nup
    #define __genplib_h_nup
    #include <nup.h>
  #endif
#endif

#ifdef INCL_GENPLIB_DBCS
  #ifndef __genplib_h_dbcs
    #define __genplib_h_dbcs
    #include <dbcs.h>
  #endif
#endif

#ifdef INCL_GENPLIB_GPLUTIL
  #ifndef __genplib_h_gplutil
    #define __genplib_h_gplutil
    #include <util.h>
  #endif
#endif

#ifdef INCL_GENPLIB_RUNTIME
  #include <runtime.h>
#endif

#ifdef INCL_GENPLIB_MEMINI
   #include <memini.h>
#endif

#ifdef INCL_GENPLIB_CTRLLISTBOX
  #ifndef __genplib_h_ctrllistbox
    #define __genplib_h_ctrllistbox
    #include <listbox.h>
  #endif
#endif

#ifdef INCL_GENPLIB_LAYOUT
  #ifndef __genplib_h_layout
    #define __genplib_h_layout
    #include <glayout.h>
  #endif
#endif

#ifdef INCL_GENPLIB_FIXEDMATH
  #ifndef __genplib_h_fixedmath
    #define __genplib_h_fixedmath
    #include <fxmath.h>
  #endif
#endif

#ifdef INCL_GENPLIB_EDC
  #ifndef __genplib_h_edc
    #define __genplib_h_edc
    #include <gpledc.h>
  #endif
#endif

#ifdef INCL_GENPLIB_BOOKLET
  #ifndef __genplib_h_booklet
    #define __genplib_h_booklet
    #include <booklet.h>
  #endif
#endif

#ifdef INCL_GENPLIB_FONTMGR
  #ifndef __genplib_h_fontmgr
    #define __genplib_h_fontmgr
    #include <fontmgr.h>
  #endif
#endif

#ifdef INCL_GENPLIB_WEBPAGE
  #ifndef __genplib_h_webpage
    #define __genplib_h_webpage
    #include <webpage.h>
  #endif
#endif

#if __cplusplus
}
#endif
