/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = HANDLER.H
 *
 * DESCRIPTION = Exception handling/management routines
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 04/01/96
 * AUTHOR  = Monte Copeland / Mark Hamzy
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_handler_h
#define _gpl_handler_h

// exception handling definitions and macros

// FNEH is a typedef for an exception handler function
typedef ULONG _System FNEH( PEXCEPTIONREPORTRECORD, PEXCEPTIONREGISTRATIONRECORD, PCONTEXTRECORD, PVOID );
typedef FNEH *PFNEH;

// typedef for a handler registration record; a link in a list
struct _regrec {
  PEXCEPTIONREGISTRATIONRECORD pnext;       // req'd by os2
  PFNEH                        pfn;         // req'd by os2
  jmp_buf                      jmp;         // additional field for C runtime longjmp support
  HMODULE                      hModule;     // additional field
};
typedef struct _regrec REGREC, *PREGREC;

#define REGISTERHANDLER(regrec, hmod)                               \
  memset (&regrec, 0, sizeof (regrec));                             \
  regrec.pfn = GplHandler;                                          \
  regrec.hModule = hmod;                                            \
  DosSetExceptionHandler ((PEXCEPTIONREGISTRATIONRECORD) &regrec);

#define UNREGISTERHANDLER(regrec)  DosUnsetExceptionHandler ((PEXCEPTIONREGISTRATIONRECORD)&regrec);

#define XCPT_USER         0xC0C00ABC

#define RAISEEXCEPTION(exnum) {                                    \
  EXCEPTIONREPORTRECORD err;                                       \
  err.ExceptionNum = exnum;                                        \
  memset (&err, 0, sizeof (err));                                  \
  DosRaiseException (&err);                                        \
}

extern ULONG _System GplHandler (PEXCEPTIONREPORTRECORD p1,
                                 PEXCEPTIONREGISTRATIONRECORD p2,
                                 PCONTEXTRECORD p3,
                                 PVOID pv);

#endif
