/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = NUP.H
 *
 * DESCRIPTION = Public output N-UP (Layout) header for GENPLIB.LIB
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 04/04/96
 * AUTHOR  = Larry Moore
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_nup_h
#define _gpl_nup_h

/*****************************************************************************\
** DEFINES                                                                   **
\*****************************************************************************/
#define GJFN_CB_ID              0x504E4A47                 /* 7-21-1998 */
                                // P N J G

#define GJFN_QUERY_NUP_SELECTED      0x0001
#define GJFN_QUERY_NUP_COLUMNS       0x0002
#define GJFN_QUERY_NUP_ROWS          0x0003
#define GJFN_QUERY_NUP_ROTATION      0x0004
#define GJFN_QUERY_NUP_BORDERS       0x0005
#define GJFN_QUERY_BOOKLET_ENABLED   0x0006  
#define GJFN_QUERY_BOOKLET_RANGE     0x0007  
#define GJFN_QUERY_BOOKLET_UPPERTRAY 0x0008  

/*
** This macro contains the maximum number of NUP values.  For any additions to
** the NUP GJFN_QUERY... macros above, this vaule must be incremented.
*/
#define GJFN_QUERY_ALL_NUP_VALUES   8            

#define GJFN_QUERY_FTP_PAGESIZE     0x0001
#define GJFN_QUERY_FTP_SCALETOFIT   0x0002
/*
** This macro contains the maximum number of FTP values.  For any additions to
** the FTP GJFN_QUERY... macros above, this vaule must be incremented.
*/
#define GJFN_QUERY_ALL_FTP_VALUES   2

#define GJFN_QUERY_SCALE_SCALE      0x0001
/*
** This macro contains the maximum number of SCALING values.  For any additions to
** the FTP GJFN_QUERY... macros above, this vaule must be incremented.
*/
#define GJFN_QUERY_ALL_SCALE_VALUES 1


#ifndef GDNID_BASE
#define GDNID_BASE                      0x3000
#define GDNID_NUPGROUP                  GDNID_BASE
#define GDNID_NUMPGTEXT                 (GDNID_BASE + 1)
#define GDNID_PAGESPERSHEET             (GDNID_BASE + 2)
#define GDNID_PRINTBORDER               (GDNID_BASE + 3)

#define GDNID_FITTOPAGE_GROUP           (GDNID_BASE + 4)
#define GDNID_FITTOPAGE_PRINTON         (GDNID_BASE + 5)
#define GDNID_FITTOPAGE_PRINTONSIZE     (GDNID_BASE + 6)
#define GDNID_FITTOPAGE_PRINTONSCALE    (GDNID_BASE + 7)

#define GDNID_SCALING_GROUP             (GDNID_BASE + 8)
#define GDNID_SCALING                   (GDNID_BASE + 9)
#define GDNID_SCALING_VALUE             (GDNID_BASE + 10)

#define GDNID_BOOKLETPRINT              (GDNID_BASE + 11)
#define GDNID_BOOKLETRANGE              (GDNID_BASE + 12)
#define GDNID_BOOKLETALLPAGES           (GDNID_BASE + 13)
#define GDNID_BOOKLETSELECTPAGES        (GDNID_BASE + 14)
#define GDNID_BOOKLETRANGEOFPAGES       (GDNID_BASE + 15)
#define GDNID_BOOKLETRANGETEXT          (GDNID_BASE + 16)
#define GDNID_BOOKLETUPPERTRAY          (GDNID_BASE + 17)

// Old stuff
#define GDNID_NUPDIALOG             0x8200
#define GDNID_STRINGBASE            (GDNID_BASE + 0x8000)
#define GNSID_1                     GDNID_STRINGBASE
#define GNSID_2                     (GDNID_STRINGBASE + 1)
#define GNSID_4                     (GDNID_STRINGBASE + 2)
#define GNSID_6                     (GDNID_STRINGBASE + 3)
#define GNSID_8                     (GDNID_STRINGBASE + 4)
#define GNSID_9                     (GDNID_STRINGBASE + 5)
#define GNSID_16                    (GDNID_STRINGBASE + 6)
#define GDNID_SAMPLEPAGE            0x8201
#define GDNID_UNDO                  0x8202
#define GDNID_DEFAULTS              0x8203
#define GDNID_CONTEXTHELP           0x8204
#endif


/*****************************************************************************\
** TYPEDEF DEFINITIONS                                                       **
\*****************************************************************************/
typedef struct _GJNCB
{
  ULONG ulNumPgSheet;                 // Number of pages per sheet
  ULONG ulFlags;                      // Local flags
        // If set then the page borders are not printed
        #define GNDF_NOPRINTBORDER      0x00000001
        #define GNDF_NOFTP              0x00000002
        #define GNDF_NOSCALING          0x00000004
        #define GNDF_BOOKLETENABLED     0x00000008  
        #define GNDF_BOOKLETOMNI        0x00000010  
        #define GNDF_BOOKLETUPPERTRAY   0x00000020  

  ULONG ulReserved;                   // Reserved - must be 0

        #define  BOOKLET_MAX_RANGES_SIZE   40       
  CHAR  szBookletRangeOfPages[BOOKLET_MAX_RANGES_SIZE]; 

} GJNCB, *PGJNCB;

typedef struct _GJFTPCB
{
  ULONG ulFlags;
        // If set, then scale to fit on the page.
        #define GNDF_SCALETOFIT    1

  CHAR  aPageSize[ 33 ];              // Page size selected.

  ULONG ulScale;                      // Scaling factor

  ULONG ulReserved;                   // Reserved - must be 0
} GJFTPCB, *PGJFTPCB;

typedef struct _GJSCB
{
  ULONG ulFlags;

  ULONG ulScale;                      // Scaling factor

  ULONG ulReserved;                   // Reserved - must be 0
} GJSCB, *PGJSCB;





/*****************************************************************************\
** FUNCTION PROTOTYPES                                                       **
\*****************************************************************************/
VOID  APIENTRY GplNUPResetCB( PGJNCB );
LONG  APIENTRY GplNUPQueryParameters( HDC, PGJNCB, PULONG, ULONG, ULONG );
ULONG APIENTRY GplNUPSaveSettings( HWND, PVOID );
LONG  APIENTRY GplFittopageQueryParameters( PGJFTPCB, PULONG, ULONG, ULONG );
#endif
