/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = PATTERN.H
 *
 * DESCRIPTION = This contains functions dealing with the creation and
 *               deletion of OS/2 pattern primitives into bitmaps.
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 12-21-94
 * AUTHOR  = Tom Spurrier
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_pattern_h
#define _gpl_pattern_h

#define GPLPAT_INVERT_BITS    1

LONG APIENTRY GplPatternCreateBitmaps(HMCB      hMcb,
                                      ULONG     ulXResolution,
                                      ULONG     ulYResolution,
                                      ULONG     ulWidth,
                                      ULONG     ulHeight,
                                      PBMAPINFO paBmapInfo,
                                      LONG      lCount,
                                      ULONG      ulflip);


LONG APIENTRY GplPatternCreate(HMCB       hMcb,
                               ULONG      ulXResolution,
                               ULONG      ulYResolution,
                               ULONG      ulPatSym,
                               PBMAPINFO  pBmapInfo,
                               ULONG      ulflip);

LONG APIENTRY GplPatternDeleteBitmaps(HMCB      hMcb,
                                      PBMAPINFO paBmapInfo,
                                      LONG      lCount);

#endif
