/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = THRDWRITE.H
 *
 * DESCRIPTION = Helper functions for writing to THREAD.H functions.
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 04/0/1/94
 * AUTHOR  = Mark Hamzy
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef _gpl_thdwrite_h
#define _gpl_thdwrite_h

BOOL APIENTRY GplThreadWriteCommandWithWord    (PVOID  hThread,
                                                PBYTE  pbCommand,
                                                USHORT usWord,
                                                ULONG  ulLength);
BOOL APIENTRY GplThreadWriteASCIICommand       (PVOID  hThread,
                                                PSZ    pszCommand);
BOOL APIENTRY GplThreadWriteBlock              (PVOID  hThread,
                                                PBYTE  pbBlock,
                                                ULONG  ulLength);
BOOL APIENTRY GplThreadWriteCommandWithPrintf  (PVOID  hThread,
                                                USHORT usLength,
                                                PSZ    pszCommand,
                                                       ...);

BOOL APIENTRY GplThreadBufferCommandWithWord   (PBYTE  pbByte,
                                                PINT   pIndex,
                                                PBYTE  pbCommand,
                                                USHORT usWord,
                                                ULONG  ulLength);
BOOL APIENTRY GplThreadBufferCommandWithPrintf (PBYTE  pbByte,
                                                PINT   pIndex,
                                                USHORT usLength,
                                                PSZ    pszCommand,
                                                       ...);
BOOL APIENTRY GplThreadBufferASCIICommand      (PBYTE  pbByte,
                                                PINT   pIndex,
                                                PSZ    pszCommand);
BOOL APIENTRY GplThreadBufferBlock             (PBYTE  pbByte,
                                                PINT   pIndex,
                                                PBYTE  pbBlock,
                                                ULONG  ulLength);
BOOL APIENTRY GplThreadBufferWord              (PBYTE  pbByte,
                                                PINT   pIndex,
                                                USHORT usWord);

#endif
