/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = WEBPAGE.H
 *
 * DESCRIPTION = Public header information for Web Download notebook page 
 *               functions(WEBPAGE.C)
 *
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation. This sample code is not
 * part of any standard or IBM product and is provided to you solely
 * for  the purpose of assisting you in the development of your
 * presentation drivers.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 *
 * VERSION = V1.0
 * DATE    = 04/12/00
 * AUTHOR  = Valters Vingolds
 *
 * FUNCTIONS
 *
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 *
 * EXTERNAL REFERENCES
 *
 *
 * EXTERNAL FUNCTIONS
 *
 *
*/

#ifndef __gpl_webpage_h
#define __gpl_webpage_h


//
typedef struct _WEBPAGE_DRIVERINFO
{
  PSZ     pszHomeURL;          // Driver defined URL for driver/device home
  PSZ     pszDriverURL;        // Driver defined URL for driver download
  PSZ     pszKeyApp;           // Driver's profile name (save/read settings)
} WEBPAGE_DRIVERINFO, *PWEBPAGE_DRIVERINFO;

//
typedef struct _GWPCB
{
  ULONG   ulReserved;          // Reserved - must be 0
} GWPCB, *PGWPCB, **PPGWPCB;


// GENPLIB WebPage Callback Procedure
typedef MRESULT (APIENTRY GWPCP) (PGWPCB, PVOID);
typedef GWPCP   *PGWPCP, **PPGWPCP;

// create WebPage Instance
HGJPI APIENTRY
GplWebCreatePage(
   HGJNI    hNBInstance,
   PGWPCB   pWPCB,
   PGWPCP   pCallbackProc,
   PVOID    pInstanceData,
   PWEBPAGE_DRIVERINFO pWebPageInfo
   );

// Save settings by explicit call (not needed if driver sends 
// WM_SAVESETTINGS to all notebook pages - like LASERJET or PSCRIPT do)
MRESULT APIENTRY
GplWebSaveSettings( 
   HGJPI hPageInstance 
   );

// destroy WebPage
LONG APIENTRY
GplWebDestroyPage(
   HWND    hPage,
   HGJPI   hPageInstance
   );

#endif
